test-lib.sh 7.6 KB
Newer Older
1 2 3 4 5 6 7
#!/bin/sh
#
# Copyright (c) 2005 Junio C Hamano
#

# For repeatability, reset the environment to known value.
LANG=C
8
LC_ALL=C
9
PAGER=cat
10
TZ=UTC
11
export LANG LC_ALL PAGER TZ
12 13
EDITOR=:
VISUAL=:
14
unset GIT_EDITOR
15 16 17 18 19
unset AUTHOR_DATE
unset AUTHOR_EMAIL
unset AUTHOR_NAME
unset COMMIT_AUTHOR_EMAIL
unset COMMIT_AUTHOR_NAME
20
unset EMAIL
21 22
unset GIT_ALTERNATE_OBJECT_DIRECTORIES
unset GIT_AUTHOR_DATE
23 24
GIT_AUTHOR_EMAIL=author@example.com
GIT_AUTHOR_NAME='A U Thor'
25
unset GIT_COMMITTER_DATE
26 27
GIT_COMMITTER_EMAIL=committer@example.com
GIT_COMMITTER_NAME='C O Mitter'
28 29
unset GIT_DIFF_OPTS
unset GIT_DIR
30
unset GIT_WORK_TREE
31 32 33 34 35
unset GIT_EXTERNAL_DIFF
unset GIT_INDEX_FILE
unset GIT_OBJECT_DIRECTORY
unset SHA1_FILE_DIRECTORIES
unset SHA1_FILE_DIRECTORY
36 37
GIT_MERGE_VERBOSITY=5
export GIT_MERGE_VERBOSITY
38 39
export GIT_AUTHOR_EMAIL GIT_AUTHOR_NAME
export GIT_COMMITTER_EMAIL GIT_COMMITTER_NAME
40
export EDITOR VISUAL
41

42 43 44 45
# Protect ourselves from common misconfiguration to export
# CDPATH into the environment
unset CDPATH

46
case $(echo $GIT_TRACE |tr "[A-Z]" "[a-z]") in
47 48 49 50 51 52 53 54
	1|2|true)
		echo "* warning: Some tests will not work if GIT_TRACE" \
			"is set as to trace on STDERR ! *"
		echo "* warning: Please set GIT_TRACE to something" \
			"other than 1, 2 or true ! *"
		;;
esac

55 56 57 58 59 60 61
# Each test should start with something like this, after copyright notices:
#
# test_description='Description of this test...
# This test checks if command xyzzy does the right thing...
# '
# . ./test-lib.sh

62
[ "x$TERM" != "xdumb" ] &&
63
	[ -t 1 ] &&
64 65 66 67
	tput bold >/dev/null 2>&1 &&
	tput setaf 1 >/dev/null 2>&1 &&
	tput sgr0 >/dev/null 2>&1 &&
	color=t
68 69 70 71 72 73

while test "$#" -ne 0
do
	case "$1" in
	-d|--d|--de|--deb|--debu|--debug)
		debug=t; shift ;;
J
Junio C Hamano 已提交
74 75
	-i|--i|--im|--imm|--imme|--immed|--immedi|--immedia|--immediat|--immediate)
		immediate=t; shift ;;
76
	-h|--h|--he|--hel|--help)
77
		help=t; shift ;;
78 79
	-v|--v|--ve|--ver|--verb|--verbo|--verbos|--verbose)
		verbose=t; shift ;;
80 81
	-q|--q|--qu|--qui|--quie|--quiet)
		quiet=t; shift ;;
82 83
	--no-color)
	    color=; shift ;;
84
	--no-python)
J
Junio C Hamano 已提交
85 86
		# noop now...
		shift ;;
87 88 89 90 91
	*)
		break ;;
	esac
done

92 93 94 95 96 97 98
if test -n "$color"; then
	say_color () {
		case "$1" in
			error) tput bold; tput setaf 1;; # bold red
			skip)  tput bold; tput setaf 2;; # bold green
			pass)  tput setaf 2;;            # green
			info)  tput setaf 3;;            # brown
99
			*) test -n "$quiet" && return;;
100 101 102 103 104 105 106
		esac
		shift
		echo "* $*"
		tput sgr0
	}
else
	say_color() {
107
		test -z "$1" && test -n "$quiet" && return
108 109 110 111 112 113 114 115 116 117 118 119 120 121 122
		shift
		echo "* $*"
	}
fi

error () {
	say_color error "error: $*"
	trap - exit
	exit 1
}

say () {
	say_color info "$*"
}

123 124 125 126 127 128 129 130 131
test "${test_description}" != "" ||
error "Test script did not set test_description."

if test "$help" = "t"
then
	echo "$test_description"
	exit 0
fi

132
exec 5>&1
133 134 135 136 137 138 139 140 141
if test "$verbose" = "t"
then
	exec 4>&2 3>&1
else
	exec 4>/dev/null 3>/dev/null
fi

test_failure=0
test_count=0
J
Junio C Hamano 已提交
142 143
test_fixed=0
test_broken=0
144

145 146
trap 'echo >&5 "FATAL: Unexpected exit with code $?"; exit 1' exit

147 148 149
test_tick () {
	if test -z "${test_tick+set}"
	then
J
Junio C Hamano 已提交
150
		test_tick=1112911993
151 152 153
	else
		test_tick=$(($test_tick + 60))
	fi
J
Junio C Hamano 已提交
154 155
	GIT_COMMITTER_DATE="$test_tick -0700"
	GIT_AUTHOR_DATE="$test_tick -0700"
156 157
	export GIT_COMMITTER_DATE GIT_AUTHOR_DATE
}
158

J
Junio C Hamano 已提交
159 160 161 162
# You are not expected to call test_ok_ and test_failure_ directly, use
# the text_expect_* functions instead.

test_ok_ () {
163
	test_count=$(expr "$test_count" + 1)
164
	say_color "" "  ok $test_count: $@"
165 166
}

J
Junio C Hamano 已提交
167
test_failure_ () {
168 169
	test_count=$(expr "$test_count" + 1)
	test_failure=$(expr "$test_failure" + 1);
170
	say_color error "FAIL $test_count: $1"
171 172
	shift
	echo "$@" | sed -e 's/^/	/'
173
	test "$immediate" = "" || { trap - exit; exit 1; }
J
Junio C Hamano 已提交
174 175
}

J
Junio C Hamano 已提交
176 177 178 179 180 181 182 183 184 185 186
test_known_broken_ok_ () {
	test_count=$(expr "$test_count" + 1)
	test_fixed=$(($test_fixed+1))
	say_color "" "  FIXED $test_count: $@"
}

test_known_broken_failure_ () {
	test_count=$(expr "$test_count" + 1)
	test_broken=$(($test_broken+1))
	say_color skip "  still broken $test_count: $@"
}
J
Junio C Hamano 已提交
187 188

test_debug () {
189
	test "$debug" = "" || eval "$1"
190 191
}

192 193 194 195 196 197
test_run_ () {
	eval >&3 2>&4 "$1"
	eval_ret="$?"
	return 0
}

198 199 200 201 202 203 204 205 206 207 208 209 210
test_skip () {
	this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
	this_test="$this_test.$(expr "$test_count" + 1)"
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
211
		say_color skip >&3 "skipping test: $@"
212
		test_count=$(expr "$test_count" + 1)
213
		say_color skip "skip $test_count: $1"
214 215 216 217 218 219 220 221
		: true
		;;
	*)
		false
		;;
	esac
}

222
test_expect_failure () {
223
	test "$#" = 2 ||
224
	error "bug in the test script: not 2 parameters to test-expect-failure"
225
	if ! test_skip "$@"
226
	then
J
Junio C Hamano 已提交
227
		say >&3 "checking known breakage: $2"
228
		test_run_ "$2"
J
Junio C Hamano 已提交
229
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
230
		then
J
Junio C Hamano 已提交
231
			test_known_broken_ok_ "$1"
232
		else
J
Junio C Hamano 已提交
233
		    test_known_broken_failure_ "$1"
234
		fi
235
	fi
236
	echo >&3 ""
237 238 239
}

test_expect_success () {
240
	test "$#" = 2 ||
241
	error "bug in the test script: not 2 parameters to test-expect-success"
242
	if ! test_skip "$@"
243
	then
244 245 246 247 248 249 250 251
		say >&3 "expecting success: $2"
		test_run_ "$2"
		if [ "$?" = 0 -a "$eval_ret" = 0 ]
		then
			test_ok_ "$1"
		else
			test_failure_ "$@"
		fi
252
	fi
253
	echo >&3 ""
254 255
}

256 257 258
test_expect_code () {
	test "$#" = 3 ||
	error "bug in the test script: not 3 parameters to test-expect-code"
259
	if ! test_skip "$@"
260
	then
261 262 263 264 265 266 267 268
		say >&3 "expecting exit code $1: $3"
		test_run_ "$3"
		if [ "$?" = 0 -a "$eval_ret" = "$1" ]
		then
			test_ok_ "$2"
		else
			test_failure_ "$@"
		fi
269
	fi
270
	echo >&3 ""
271 272
}

273
# Most tests can use the created repository, but some may need to create more.
274 275 276 277 278 279 280 281
# Usage: test_create_repo <directory>
test_create_repo () {
	test "$#" = 1 ||
	error "bug in the test script: not 1 parameter to test-create-repo"
	owd=`pwd`
	repo="$1"
	mkdir "$repo"
	cd "$repo" || error "Cannot setup test environment"
282 283
	"$GIT_EXEC_PATH/git" init --template=$GIT_EXEC_PATH/templates/blt/ >/dev/null 2>&1 ||
	error "cannot run git init -- have you built things yet?"
284 285 286
	mv .git/hooks .git/hooks-disabled
	cd "$owd"
}
J
Junio C Hamano 已提交
287

288
test_done () {
289
	trap - exit
J
Junio C Hamano 已提交
290 291 292 293 294 295 296 297

	if test "$test_fixed" != 0
	then
		say_color pass "fixed $test_fixed known breakage(s)"
	fi
	if test "$test_broken" != 0
	then
		say_color error "still have $test_broken known breakage(s)"
298 299 300
		msg="remaining $(($test_count-$test_broken)) test(s)"
	else
		msg="$test_count test(s)"
J
Junio C Hamano 已提交
301
	fi
302
	case "$test_failure" in
303
	0)
304 305 306 307 308 309 310 311
		# We could:
		# cd .. && rm -fr trash
		# but that means we forbid any tests that use their own
		# subdirectory from calling test_done without coming back
		# to where they started from.
		# The Makefile provided will clean this test area so
		# we will leave things as they are.

312
		say_color pass "passed all $msg"
313 314 315
		exit 0 ;;

	*)
316
		say_color error "failed $test_failure among $msg"
317 318 319 320 321 322 323 324
		exit 1 ;;

	esac
}

# Test the binaries we have just built.  The tests are kept in
# t/ subdirectory and are run in trash subdirectory.
PATH=$(pwd)/..:$PATH
J
Johannes Schindelin 已提交
325
GIT_EXEC_PATH=$(pwd)/..
J
Johannes Schindelin 已提交
326
GIT_TEMPLATE_DIR=$(pwd)/../templates/blt
J
Jeff King 已提交
327 328 329 330 331
unset GIT_CONFIG
unset GIT_CONFIG_LOCAL
GIT_CONFIG_NOSYSTEM=1
GIT_CONFIG_NOGLOBAL=1
export PATH GIT_EXEC_PATH GIT_TEMPLATE_DIR GIT_CONFIG_NOSYSTEM GIT_CONFIG_NOGLOBAL
332

333 334
GITPERLLIB=$(pwd)/../perl/blib/lib:$(pwd)/../perl/blib/arch/auto/Git
export GITPERLLIB
335 336 337
test -d ../templates/blt || {
	error "You haven't built things yet, have you?"
}
338

E
Eric Wong 已提交
339 340 341 342 343 344
if ! test -x ../test-chmtime; then
	echo >&2 'You need to build test-chmtime:'
	echo >&2 'Run "make test-chmtime" in the source (toplevel) directory'
	exit 1
fi

345 346 347
# Test repository
test=trash
rm -fr "$test"
348 349
test_create_repo $test
cd "$test"
350 351 352 353 354 355 356 357 358 359 360 361 362 363

this_test=$(expr "./$0" : '.*/\(t[0-9]*\)-[^/]*$')
for skp in $GIT_SKIP_TESTS
do
	to_skip=
	for skp in $GIT_SKIP_TESTS
	do
		case "$this_test" in
		$skp)
			to_skip=t
		esac
	done
	case "$to_skip" in
	t)
364 365
		say_color skip >&3 "skipping test $this_test altogether"
		say_color skip "skip all tests in $this_test"
366 367 368
		test_done
	esac
done